diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index f71417664..192fc82fd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -57,9 +57,11 @@ public class BlockLogicPistonMoving extends BlockLogic {
     @Override
     public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (!world.isClientSide && world.getTileEntity(tilePos) == null) {
-            int id = 0;
-            if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) id = piston.getMovedId();
-            world.setBlockIdNotify(tilePos, id);
+            @NotNull Block<?> block = Blocks.AIR;
+            if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
+                block = piston.getMovedBlock();
+            }
+            world.setBlockTypeNotify(tilePos, block);
             return true;
         } else {
             return false;
@@ -77,23 +79,20 @@ public class BlockLogicPistonMoving extends BlockLogic {
             return;
         }
         if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
-            Block<?> b = Blocks.getBlock(piston.getMovedId());
-            if (b != null) {
-                b.dropWithCause(world, EnumDropCause.WORLD, tilePos, data, null, null);
-            }
+            piston.getMovedBlock().dropWithCause(world, EnumDropCause.WORLD, tilePos, data, null, null);
         }
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!world.isClientSide) {
             world.getTileEntity(tilePos); // Im not sure if this actually does anything anymore??
         }
     }
 
-    public static TileEntity createTileEntity(int movedId, int movedData, @Nullable TileEntity movedEntity, @NotNull Direction direction, boolean extending, boolean isSourcePiston) {
+    public static TileEntity createTileEntity(final @NotNull Block<?> movedBlock, int movedData, @Nullable TileEntity movedEntity, @NotNull Direction direction, boolean extending, boolean isSourcePiston) {
         assert !(movedEntity instanceof TileEntityMovingPistonBlock) : "Moving piston entity should not be able to be put into another moving piston!";
-        return new TileEntityMovingPistonBlock(movedId, movedData, movedEntity, direction, extending, isSourcePiston);
+        return new TileEntityMovingPistonBlock(movedBlock, movedData, movedEntity, direction, extending, isSourcePiston);
     }
 
     @Override
@@ -103,7 +102,7 @@ public class BlockLogicPistonMoving extends BlockLogic {
             if (piston.isExtending()) {
                 progress = 1.0F - progress;
             }
-            return getCollisionShapeFromTileEntity(source, tilePos, piston.getMovedId(), progress, piston.getDirection());
+            return getCollisionShapeFromTileEntity(source, tilePos, piston.getMovedBlock(), progress, piston.getDirection());
         }
         return null;
     }
@@ -111,8 +110,8 @@ public class BlockLogicPistonMoving extends BlockLogic {
     @Override
     public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         if (source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
-            Block<?> block = Blocks.blocksList[piston.getMovedId()];
-            if (block == null || block == this.block) {
+            Block<?> block = piston.getMovedBlock();
+            if (block == this.block) {
                 return super.getBoundsFromState(source, tilePos);
             }
             float directionStretch = piston.getProgress(0.0F);
@@ -126,11 +125,8 @@ public class BlockLogicPistonMoving extends BlockLogic {
         return super.getBoundsFromState(source, tilePos);
     }
 
-    public @Nullable AABBdc getCollisionShapeFromTileEntity(@NotNull WorldSource source, @NotNull TilePosc tilePos, int blockID, float directionStretch, @NotNull Direction direction) {
-        if (blockID == 0 || blockID == this.block.id()) {
-            return null;
-        }
-        AABBdc aabb = Blocks.blocksList[blockID].getCollisionAABB(source, tilePos);
+    public @Nullable AABBdc getCollisionShapeFromTileEntity(@NotNull WorldSource source, @NotNull TilePosc tilePos, final @NotNull Block<?> block, float directionStretch, @NotNull Direction direction) {
+        AABBdc aabb = block.getCollisionAABB(source, tilePos);
         if (aabb == null) {
             return null;
         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index b6f04adb0..e1c81ee17 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -20,7 +20,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
     public static final int TICKS_TO_EXTEND = 2;
     private static final List<Entity> entityBuffer = new ArrayList<>();
 
-    private int movedId;
+    private @NotNull Block<?> movedBlock;
     private int movedData;
     private @Nullable TileEntity movedEntity;
     private Direction direction;
@@ -34,9 +34,9 @@ public class TileEntityMovingPistonBlock extends TileEntity
     {
     }
 
-    public TileEntityMovingPistonBlock(int movedId, int movedData, @Nullable TileEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
+    public TileEntityMovingPistonBlock(final @NotNull Block<?> movedBlock, int movedData, @Nullable TileEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
     {
-        this.movedId = movedId;
+        this.movedBlock = movedBlock;
         this.movedData = movedData;
         this.movedEntity = movedEntity;
         this.direction = direction;
@@ -45,9 +45,9 @@ public class TileEntityMovingPistonBlock extends TileEntity
         this.progress = this.progressO = 0.0F;
     }
 
-    public int getMovedId()
+    public @NotNull Block<?> getMovedBlock()
     {
-        return this.movedId;
+        return this.movedBlock;
     }
 
 	public int getMovedData()
@@ -123,7 +123,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
         } else {
             stretch = 1.0F - stretch;
         }
-        AABBdc aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(this.worldObj, new TilePos(this.x, this.y, this.z), this.movedId, stretch, this.direction);
+        AABBdc aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(this.worldObj, new TilePos(this.x, this.y, this.z), this.movedBlock, stretch, this.direction);
         if (aabb == null) return;
 
         List<Entity> list = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, aabb);
@@ -145,8 +145,8 @@ public class TileEntityMovingPistonBlock extends TileEntity
         this.progressO = this.progress = 1.0F;
         this.worldObj.removeTileEntity(selfPos);
         invalidate();
-        if(this.worldObj.getBlockId(selfPos) == Blocks.PISTON_MOVING.id()) {
-            this.worldObj.setBlockIdDataRaw(selfPos, this.movedId, this.movedData);
+        if(this.worldObj.getBlockType(selfPos) == Blocks.PISTON_MOVING) {
+            this.worldObj.setBlockTypeDataRaw(selfPos, this.movedBlock, this.movedData);
             if (this.movedEntity != null) {
                 TileEntity oldEnt = this.worldObj.getTileEntity(selfPos);
                 if (oldEnt != null) {
@@ -158,13 +158,13 @@ public class TileEntityMovingPistonBlock extends TileEntity
                 this.movedEntity.z = this.z;
                 this.worldObj.replaceTileEntity(selfPos, this.movedEntity);
             }
-            if (this.movedId != 0) {
-                Block.disableNormalEntityLogic = true;
-                Blocks.blocksList[this.movedId].onPlacedByWorld(this.worldObj, selfPos);
-                Block.disableNormalEntityLogic = false;
-            }
+
+            Block.disableNormalEntityLogic = true;
+            this.movedBlock.onPlacedByWorld(this.worldObj, selfPos);
+            Block.disableNormalEntityLogic = false;
+
             assert this.movedEntity == null || this.worldObj.getTileEntity(selfPos) == this.movedEntity : "Piston failed to actually move entity!";
-            this.worldObj.notifyBlockChange(selfPos, this.movedId);
+            this.worldObj.notifyBlockChange(selfPos, this.movedBlock);
         }
     }
 
@@ -191,7 +191,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
 
     @Override
     public void readAdditionalData(@NotNull CompoundTag compoundTag) {
-        this.movedId = compoundTag.getInteger("blockId");
+        this.movedBlock = Objects.requireNonNullElse(Blocks.getBlock(compoundTag.getInteger("blockId")), Blocks.AIR);
         this.movedData = compoundTag.getInteger("blockData");
         if (compoundTag.containsKey("tileEntity")) {
             CompoundTag entityTag = compoundTag.getCompound("tileEntity");
@@ -205,7 +205,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
     @Override
     public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        compoundTag.putInt("blockId", this.movedId);
+        compoundTag.putInt("blockId", this.movedBlock.id());
         compoundTag.putInt("blockData", this.movedData);
         if (this.movedEntity != null) {
             CompoundTag entityTag = new CompoundTag();
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
index 8527353b8..909a160f3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
@@ -12,7 +12,7 @@ public interface ISupportable {
     @NotNull ISupport getSupportConstraint(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
     default boolean isSupported(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> supportingBlock = world.getBlock(tilePos.add(side.getDirection(), new TilePos()));
+        final @Nullable Block<?> supportingBlock = world.getBlockType(tilePos.add(side.getDirection(), new TilePos()));
         if (supportingBlock == null) {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
index e2fdc58fb..a85af8cec 100644
--- a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
@@ -8,29 +8,16 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockState {
 
-	public static final BlockState AIR = new BlockState(null, 0) {
-		public int getBlockId() { return 0; }
-		public boolean is(Block<?> block) { return false; }
-		public BlockState set(int metadata) { return this; }
-		public boolean isAir() { return true; }
-		public boolean isConductor() { return false; }
-		public boolean isSignalSource() { return false; }
-		public boolean hasSignal(World world, TilePos pos, Direction dir) { return false; }
-		public boolean hasDirectSignal(World world, TilePos pos, Direction dir) { return false; }
-		public boolean canSurvive(World world, TilePos pos) { return true; }
-		public void dropItems(World world, TilePos pos) { }
-		public void neighborChanged(World world, TilePos pos, Block<?> fromBlock) { }
-	};
-
-	private final Block<?> block;
-	private final int metadata;
+	public static final @NotNull BlockState AIR = new BlockState(Blocks.AIR, 0);
 
-	public BlockState(int blockId, int metadata) {
-		this(Blocks.getBlock(blockId), metadata);
-	}
+	private final @NotNull Block<?> block;
+	private final int metadata;
 
 	public BlockState(Block<?> block, int metadata) {
 		this.block = block;
@@ -38,24 +25,19 @@ public class BlockState {
 	}
 
 	@Override
-	public boolean equals(Object obj) {
-		if (obj instanceof BlockState) {
-			BlockState state = (BlockState)obj;
-			return state.block == block && state.metadata == metadata;
+	public boolean equals(final @Nullable Object obj) {
+		if (obj instanceof final @NotNull BlockState state) {
+			return state.block == this.block && state.metadata == this.metadata;
 		}
 
 		return false;
 	}
 
-	public int getBlockId() {
-		return block.id();
-	}
-
-	public Block<?> getBlock() {
+	public @NotNull Block<?> getBlockType() {
 		return block;
 	}
 
-	public boolean is(Block<?> block) {
+	public boolean is(@NotNull Block<?> block) {
 		return this.block == block;
 	}
 
@@ -79,29 +61,29 @@ public class BlockState {
 		return block.isSignalSource();
 	}
 
-	public boolean hasSignal(World world, TilePos pos, Direction dir) {
-		return block.getSignal(world, pos.x, pos.y, pos.z, dir.getSide());
+	public boolean hasSignal(World world, TilePosc pos, Direction dir) {
+		return block.isEmittingSignal(world, pos, dir.getSide());
 	}
 
-	public boolean hasDirectSignal(World world, TilePos pos, Direction dir) {
-		return block.getDirectSignal(world, pos.x, pos.y, pos.z, dir.getSide());
+	public boolean hasDirectSignal(World world, TilePosc pos, Direction dir) {
+		return block.isEmittingDirectSignal(world, pos, dir.getSide());
 	}
 
-	public boolean canSurvive(World world, TilePos pos) {
-		Block<?> block = world.getBlock(pos.x, pos.y, pos.z);
+	public boolean canSurvive(World world, TilePosc pos) {
+		Block<?> block = world.getBlockType(pos);
 		if (block == Blocks.WIRE_REDSTONE) {
             return Blocks.WIRE_REDSTONE.getLogic().isSupported(world, pos, Side.BOTTOM);
 		} else {
-			Block<?> underBlock = world.getBlock(pos.x, pos.y - 1, pos.z);
-			return (block == null || block.getMaterial().isReplaceable()) && underBlock != null && underBlock.isCubeShaped();
+			Block<?> underBlock = world.getBlockType(pos.down(new TilePos()));
+			return block.getMaterial().isReplaceable() && underBlock.isCubeShaped();
 		}
 	}
 
 	public void dropItems(World world, TilePos pos) {
-		block.dropBlockWithCause(world, EnumDropCause.WORLD, pos.x, pos.y, pos.z, 0, null, null);
+		block.dropWithCause(world, EnumDropCause.WORLD, pos, 0, null, null);
 	}
 
 	public void neighborChanged(World world, TilePos pos, Block<?> neighborBlock) {
-		block.onNeighborBlockChange(world, pos.x, pos.y, pos.z, neighborBlock.id());
+		block.onNeighborChanged(world, pos, neighborBlock);
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
index 578ce8242..ccc694224 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
@@ -995,7 +995,7 @@ public class WireHandler {
                 WireNode neighborWire = node.neighborWire;
 
                 if (neighborWire != null) {
-                    updateBlock(node, neighborWire.state.getBlock());
+                    updateBlock(node, neighborWire.state.getBlockType());
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
index cca46b4a4..b949ee832 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
@@ -114,7 +114,7 @@ class WireNode extends Node {
 
         if (this.shouldBreak) {
             this.state.dropItems(this.world, this.pos);
-            this.world.setBlockId(this.pos, 0);
+            this.world.setBlockType(this.pos, Blocks.AIR);
 
             return true;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
index 722ce72e7..ade1e452a 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.current.wire;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.current.util.BlockState;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -15,13 +17,13 @@ class WorldHelper {
             return BlockState.AIR;
         }
 
-        int blockId = world.getBlockId(pos);
+        final @NotNull Block<?> block = world.getBlockType(pos);
 
-        if (blockId == 0) {
+        if (block == Blocks.AIR) {
             return BlockState.AIR;
         }
 
-        return new BlockState(blockId, world.getBlockData(pos));
+        return new BlockState(block, world.getBlockData(pos));
     }
 
     /**
@@ -35,10 +37,10 @@ class WorldHelper {
             return false;
         }
 
-        int blockId = state.getBlockId();
-        int prevBlockId = world.getBlockId(pos);
+        @NotNull Block<?> block = state.getBlockType();
+        @NotNull Block<?> prevBlock = world.getBlockType(pos);
 
-        if (blockId != prevBlockId) {
+        if (block != prevBlock) {
             return false;
         }
 
@@ -52,7 +54,7 @@ class WorldHelper {
         world.setBlockData(pos, metadata);
 
         // notify clients of the BlockState change
-        world.notifyBlockChange(pos, blockId);
+        world.notifyBlockChange(pos, block);
         // mark the chunk for saving
         world.markBlockDirty(pos);
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 058afc505..27f6908a4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -736,7 +736,7 @@ public abstract class Entity
     public boolean isUnderLiquid(@NotNull Material material) {
         double headY = this.y + (double) getHeadHeight();
         TilePos tilePos = new TilePos(this.x, headY, this.z);
-        Block<?> block = this.world.getBlock(tilePos);
+        Block<?> block = this.world.getBlockType(tilePos);
         if (block != null && block.getMaterial() == material) {
             float f = BlockLogicFluid.getHeight(this.world.getBlockData(tilePos)) - 0.2F;
             float f1 = (float) (tilePos.y + 1) - f;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index 5024b055a..583a3aa94 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -202,7 +202,7 @@ public class EntityFallingBlock extends Entity
 
         final int skylight;
         final int blocklight;
-        if (this.world.getBlockLitInteriorSurface(blockPos) || this.world.getBlock(blockPos) == this.carriedBlock.block()) {
+        if (this.world.getBlockLitInteriorSurface(blockPos) || this.world.getBlockType(blockPos) == this.carriedBlock.block()) {
             TilePos queryPos = new TilePos();
 
             int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
index 59eef94b5..dbc9e63d0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
@@ -186,7 +186,7 @@ public class EntityFishingBobber extends Entity {
             }
         }
         if (isInGround() && this.tilePos != null) {
-            if (this.world.getBlockId(this.tilePos) == Blocks.ROPE.id()) {
+            if (this.world.getBlockType(this.tilePos) == Blocks.ROPE) {
                 this.x = this.tilePos.x + 0.5D;
                 this.y = this.tilePos.y + 0.5D;
                 this.z = this.tilePos.z + 0.5D;
@@ -208,7 +208,7 @@ public class EntityFishingBobber extends Entity {
         nextPos = new Vector3d(this.x + this.xd, this.y + this.yd, this.z + this.zd);
         if (clip != null) {
             nextPos = clip.location;
-            if (clip instanceof HitResult.Tile hitTile && this.world.getBlockId(hitTile.tilePos) == Blocks.ROPE.id()) {
+            if (clip instanceof HitResult.Tile hitTile && this.world.getBlockType(hitTile.tilePos) == Blocks.ROPE) {
                 setInGround(true);
                 this.tilePos = new TilePos(hitTile.tilePos);
             }
@@ -286,7 +286,7 @@ public class EntityFishingBobber extends Entity {
                     rainRate = 200;
                 }
 
-                if (this.world.getBlockId(tileAbove) == Blocks.ALGAE.id()) {
+                if (this.world.getBlockType(tileAbove) == Blocks.ALGAE) {
                     algaeRate = 100;
                 }
                 catchRate = (catchRate - rainRate) - algaeRate;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 56f029b0d..68e76d4b4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -23,6 +23,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3d;
@@ -1071,6 +1072,7 @@ public abstract class Mob extends Entity {
         if (Blocks.hasTag(this.world.getBlockId(blockX, blockY, blockZ), BlockTags.PREVENT_MOB_SPAWNS)) {
             return false;
         }
+        if (!this.world.areBlocksLoaded(new TilePos(this.bb.minX - 1, this.bb.minY - 1, this.bb.minZ - 1), new TilePos(this.bb.maxX + 1, this.bb.maxY + 1, this.bb.maxZ + 1))) return false;
         return this.world.checkIfAABBIsClear(this.bb) && this.world.getCubes(this, this.bb).isEmpty() && !this.world.getIsAnyLiquid(this.bb);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
index f7e47a5ca..12037448a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
@@ -5,6 +5,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3dc;
@@ -146,7 +147,7 @@ public abstract class MobPathfinder extends Mob {
             int x1 = MathHelper.floor((this.x + (double) this.random.nextInt(13)) - 6D);
             int y1 = MathHelper.floor((this.y + (double) this.random.nextInt(7)) - 3D);
             int z1 = MathHelper.floor((this.z + (double) this.random.nextInt(13)) - 6D);
-            float currentPathWeight = getBlockPathWeight(x1, y1, z1);
+            float currentPathWeight = getBlockPathWeight(new TilePos(x1, y1, z1));
             if (currentPathWeight > bestPathWeight) {
                 bestPathWeight = currentPathWeight;
                 if (tilePos != null) {
@@ -168,7 +169,7 @@ public abstract class MobPathfinder extends Mob {
     protected void attackBlockedEntity(@NotNull Entity entity, float f) {
     }
 
-    protected float getBlockPathWeight(int x, int y, int z) {
+    protected float getBlockPathWeight(@NotNull TilePosc blockPos) {
         return 0.0F;
     }
 
@@ -178,10 +179,7 @@ public abstract class MobPathfinder extends Mob {
 
     @Override
     public boolean canSpawnHere() {
-        int x = MathHelper.floor(this.x);
-        int y = MathHelper.floor(this.bb.minY);
-        int z = MathHelper.floor(this.z);
-        return super.canSpawnHere() && getBlockPathWeight(x, y, z) >= 0.0F;
+        return super.canSpawnHere() && getBlockPathWeight(new TilePos(this)) >= 0.0F;
     }
 
     public boolean hasPath() {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
index 189ea6dde..94fdaef6e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
@@ -8,6 +8,8 @@ import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
 
@@ -61,14 +63,14 @@ public abstract class MobAnimal extends MobPathfinder
     }
 
     @Override
-	protected float getBlockPathWeight(int x, int y, int z)
-    {
-        if(world.getBlockId(x, y - 1, z) == Blocks.GRASS.id())
+	protected float getBlockPathWeight(@NotNull TilePosc blockPos) {
+        if (!world.isBlockLoaded(blockPos)) return 0;
+        if(world.getBlockType(blockPos.down(new TilePos())) == Blocks.GRASS)
         {
             return 10F;
         } else
         {
-            return world.getLightBrightness(x, y, z) - 0.5F;
+            return world.getLightBrightness(blockPos) - 0.5F;
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index 58dd6c077..47b147bf1 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -184,7 +184,7 @@ public class MobGhast extends MobFlying
         AABBd aabb = new AABBd(this.bb);
         for (int i = 1; (double) i < d3; i++) {
             aabb.translate(d4, d5, d6);
-            if (!this.world.getCubes(this, aabb).isEmpty()) {
+            if (!this.world.areBlocksLoaded(aabb) || !this.world.getCubes(this, aabb).isEmpty()) {
                 return false;
             }
         }
@@ -233,7 +233,7 @@ public class MobGhast extends MobFlying
         return
             this.world.getDifficulty().canHostileMobsSpawn() &&
                 this.random.nextInt(20) == 0 &&
-                BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlock(new TilePos(this.x, this.y - this.heightOffset - 1, this.z))) &&
+                BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlockType(new TilePos(this.x, this.y - this.heightOffset - 1, this.z))) &&
                 super.canSpawnHere();
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java
index badeaf224..69a8bfe46 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java
@@ -1,7 +1,8 @@
 package net.minecraft.core.entity.monster;
 
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public class MobGiant extends MobZombie
 {
@@ -21,8 +22,8 @@ public class MobGiant extends MobZombie
         return super.getMaxHealth() * 10;
     }
     @Override
-	protected float getBlockPathWeight(final int x, final int y, final int z)
-    {
-        return this.world.getLightBrightness(x, y, z) - 0.5F;
+	protected float getBlockPathWeight(@NotNull TilePosc blockPos) {
+        if (!this.world.isBlockLoaded(blockPos)) return 0;
+        return this.world.getLightBrightness(blockPos) - 0.5F;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
index 36c2398a5..4b5c6377f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
@@ -8,6 +8,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Vector3d;
@@ -109,8 +110,9 @@ public abstract class MobMonster extends MobPathfinder
     }
 
     @Override
-    protected float getBlockPathWeight(int x, int y, int z) {
-        return 0.5F - this.world.getLightBrightness(x, y, z);
+    protected float getBlockPathWeight(@NotNull TilePosc blockPos) {
+        if (!this.world.isBlockLoaded(blockPos)) return 0;
+        return 0.5F - this.world.getLightBrightness(blockPos);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
index e860ff6f2..297204471 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
@@ -73,10 +73,11 @@ public class MobZombiePig extends MobZombie {
     public boolean canSpawnHere() {
         TilePos tilePos = new TilePos(this);
         if (!this.world.isAirBlock(tilePos)) return false;
-        Block<?> below = this.world.getBlock(tilePos.down(new TilePos()));
+        Block<?> below = this.world.getBlockType(tilePos.down(new TilePos()));
         if (!BlockTags.NETHER_MOBS_SPAWN.appliesTo(below)) return false;
         int blockLight = this.world.getSavedLightValue(LightLayer.Block, tilePos);
         if (blockLight > 7) return false;
+        if (!this.world.areBlocksLoaded(new TilePos(this.bb.minX - 1, this.bb.minY - 1, this.bb.minZ - 1), new TilePos(this.bb.maxX + 1, this.bb.maxY + 1, this.bb.maxZ + 1))) return false;
         return this.world.getDifficulty().canHostileMobsSpawn() && this.world.checkIfAABBIsClear(this.bb) && this.world.getCubes(this, this.bb).isEmpty() && !this.world.getIsAnyLiquid(this.bb);
     }
 
